/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Order
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Order {
  @SerializedName("order_id")
  private String orderId = null;

  @SerializedName("customer_id")
  private String customerId = null;

  @SerializedName("quote_id")
  private String quoteId = null;

  @SerializedName("service")
  private String service = null;

  @SerializedName("cause")
  private String cause = null;

  @SerializedName("place_type")
  private String placeType = null;

  @SerializedName("status")
  private String status = null;

  @SerializedName("vehicle")
  private Model24 vehicle = null;

  @SerializedName("is_payer_the_customer")
  private Boolean isPayerTheCustomer = null;

  @SerializedName("payer")
  private Payer payer = null;

  @SerializedName("current_location")
  private Model30 currentLocation = null;

  @SerializedName("destination_location")
  private Model30 destinationLocation = null;

  @SerializedName("to_schedule_on")
  private String toScheduleOn = null;

  public Order orderId(String orderId) {
    this.orderId = orderId;
    return this;
  }

   /**
   * Order unique identifier
   * @return orderId
  **/
  @ApiModelProperty(required = true, value = "Order unique identifier")
  public String getOrderId() {
    return orderId;
  }

  public void setOrderId(String orderId) {
    this.orderId = orderId;
  }

  public Order customerId(String customerId) {
    this.customerId = customerId;
    return this;
  }

   /**
   * Customer unique identifier
   * @return customerId
  **/
  @ApiModelProperty(required = true, value = "Customer unique identifier")
  public String getCustomerId() {
    return customerId;
  }

  public void setCustomerId(String customerId) {
    this.customerId = customerId;
  }

  public Order quoteId(String quoteId) {
    this.quoteId = quoteId;
    return this;
  }

   /**
   * Quote identifier
   * @return quoteId
  **/
  @ApiModelProperty(value = "Quote identifier")
  public String getQuoteId() {
    return quoteId;
  }

  public void setQuoteId(String quoteId) {
    this.quoteId = quoteId;
  }

  public Order service(String service) {
    this.service = service;
    return this;
  }

   /**
   * Requested service. Expected values (TOWING, CRANING, ROADSIDE_REPAIR)
   * @return service
  **/
  @ApiModelProperty(example = "TOWING", required = true, value = "Requested service. Expected values (TOWING, CRANING, ROADSIDE_REPAIR)")
  public String getService() {
    return service;
  }

  public void setService(String service) {
    this.service = service;
  }

  public Order cause(String cause) {
    this.cause = cause;
    return this;
  }

   /**
   * Cause of the vehicle issue. Expected values (ACCIDENT, STARTING_ISSUE, MECHANIC_BREAKDOWN, NO_FUEL, TIRES, OTHERS)
   * @return cause
  **/
  @ApiModelProperty(example = "MECHANIC_BREAKDOWN", value = "Cause of the vehicle issue. Expected values (ACCIDENT, STARTING_ISSUE, MECHANIC_BREAKDOWN, NO_FUEL, TIRES, OTHERS)")
  public String getCause() {
    return cause;
  }

  public void setCause(String cause) {
    this.cause = cause;
  }

  public Order placeType(String placeType) {
    this.placeType = placeType;
    return this;
  }

   /**
   * Type of the place where the vehicle is parked. Expected values (BASEMENT, HIGHWAY, MULTISTOREY_PARK, OTHER)
   * @return placeType
  **/
  @ApiModelProperty(example = "BASEMENT", value = "Type of the place where the vehicle is parked. Expected values (BASEMENT, HIGHWAY, MULTISTOREY_PARK, OTHER)")
  public String getPlaceType() {
    return placeType;
  }

  public void setPlaceType(String placeType) {
    this.placeType = placeType;
  }

  public Order status(String status) {
    this.status = status;
    return this;
  }

   /**
   * Status of Order. Expected values (NEW, ON_DEMAND, CANCELED, PRE_ASSIGNED, ASSIGNED, ACCEPTED, PAYMENT_PENDING, PAYMENT_FAILED, CLOSED_NOT_ACCEPTED, CLOSED_ACCEPTED)
   * @return status
  **/
  @ApiModelProperty(required = true, value = "Status of Order. Expected values (NEW, ON_DEMAND, CANCELED, PRE_ASSIGNED, ASSIGNED, ACCEPTED, PAYMENT_PENDING, PAYMENT_FAILED, CLOSED_NOT_ACCEPTED, CLOSED_ACCEPTED)")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public Order vehicle(Model24 vehicle) {
    this.vehicle = vehicle;
    return this;
  }

   /**
   * Get vehicle
   * @return vehicle
  **/
  @ApiModelProperty(required = true, value = "")
  public Model24 getVehicle() {
    return vehicle;
  }

  public void setVehicle(Model24 vehicle) {
    this.vehicle = vehicle;
  }

  public Order isPayerTheCustomer(Boolean isPayerTheCustomer) {
    this.isPayerTheCustomer = isPayerTheCustomer;
    return this;
  }

   /**
   * Indicates if the customer is the payer, if the value is &#39;false&#39; so the payer is mandatory
   * @return isPayerTheCustomer
  **/
  @ApiModelProperty(example = "true", value = "Indicates if the customer is the payer, if the value is 'false' so the payer is mandatory")
  public Boolean isIsPayerTheCustomer() {
    return isPayerTheCustomer;
  }

  public void setIsPayerTheCustomer(Boolean isPayerTheCustomer) {
    this.isPayerTheCustomer = isPayerTheCustomer;
  }

  public Order payer(Payer payer) {
    this.payer = payer;
    return this;
  }

   /**
   * Get payer
   * @return payer
  **/
  @ApiModelProperty(value = "")
  public Payer getPayer() {
    return payer;
  }

  public void setPayer(Payer payer) {
    this.payer = payer;
  }

  public Order currentLocation(Model30 currentLocation) {
    this.currentLocation = currentLocation;
    return this;
  }

   /**
   * Get currentLocation
   * @return currentLocation
  **/
  @ApiModelProperty(value = "")
  public Model30 getCurrentLocation() {
    return currentLocation;
  }

  public void setCurrentLocation(Model30 currentLocation) {
    this.currentLocation = currentLocation;
  }

  public Order destinationLocation(Model30 destinationLocation) {
    this.destinationLocation = destinationLocation;
    return this;
  }

   /**
   * Get destinationLocation
   * @return destinationLocation
  **/
  @ApiModelProperty(value = "")
  public Model30 getDestinationLocation() {
    return destinationLocation;
  }

  public void setDestinationLocation(Model30 destinationLocation) {
    this.destinationLocation = destinationLocation;
  }

  public Order toScheduleOn(String toScheduleOn) {
    this.toScheduleOn = toScheduleOn;
    return this;
  }

   /**
   * Date and time requested by the customer to schedule the service - UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mmZ).
   * @return toScheduleOn
  **/
  @ApiModelProperty(value = "Date and time requested by the customer to schedule the service - UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mmZ).")
  public String getToScheduleOn() {
    return toScheduleOn;
  }

  public void setToScheduleOn(String toScheduleOn) {
    this.toScheduleOn = toScheduleOn;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Order order = (Order) o;
    return Objects.equals(this.orderId, order.orderId) &&
        Objects.equals(this.customerId, order.customerId) &&
        Objects.equals(this.quoteId, order.quoteId) &&
        Objects.equals(this.service, order.service) &&
        Objects.equals(this.cause, order.cause) &&
        Objects.equals(this.placeType, order.placeType) &&
        Objects.equals(this.status, order.status) &&
        Objects.equals(this.vehicle, order.vehicle) &&
        Objects.equals(this.isPayerTheCustomer, order.isPayerTheCustomer) &&
        Objects.equals(this.payer, order.payer) &&
        Objects.equals(this.currentLocation, order.currentLocation) &&
        Objects.equals(this.destinationLocation, order.destinationLocation) &&
        Objects.equals(this.toScheduleOn, order.toScheduleOn);
  }

  @Override
  public int hashCode() {
    return Objects.hash(orderId, customerId, quoteId, service, cause, placeType, status, vehicle, isPayerTheCustomer, payer, currentLocation, destinationLocation, toScheduleOn);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Order {\n");
    
    sb.append("    orderId: ").append(toIndentedString(orderId)).append("\n");
    sb.append("    customerId: ").append(toIndentedString(customerId)).append("\n");
    sb.append("    quoteId: ").append(toIndentedString(quoteId)).append("\n");
    sb.append("    service: ").append(toIndentedString(service)).append("\n");
    sb.append("    cause: ").append(toIndentedString(cause)).append("\n");
    sb.append("    placeType: ").append(toIndentedString(placeType)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    vehicle: ").append(toIndentedString(vehicle)).append("\n");
    sb.append("    isPayerTheCustomer: ").append(toIndentedString(isPayerTheCustomer)).append("\n");
    sb.append("    payer: ").append(toIndentedString(payer)).append("\n");
    sb.append("    currentLocation: ").append(toIndentedString(currentLocation)).append("\n");
    sb.append("    destinationLocation: ").append(toIndentedString(destinationLocation)).append("\n");
    sb.append("    toScheduleOn: ").append(toIndentedString(toScheduleOn)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

